// Con Clase Febrero 2023
// Ejemplo de extraccin de atributos
// Aadir en las opciones de compilador:
// xml2.dll para usar la versin dinmica de libxml2

#include <iostream>
#include <libxml/HTMLparser.h>
#include <libxml/xpath.h>

using namespace std;

void MostrarNodos(xmlNodeSetPtr nodos);

int main()
{
    int opts = HTML_PARSE_NOBLANKS | HTML_PARSE_NOERROR | HTML_PARSE_NOWARNING | HTML_PARSE_NONET;
    htmlDocPtr doc = htmlReadFile("ejemplo.html", NULL, opts);
    xmlChar *xpath = (xmlChar*) "//a/@href";
    xmlXPathContextPtr context = xmlXPathNewContext(doc);
    xmlXPathObjectPtr result = xmlXPathEvalExpression(xpath, context);
    MostrarNodos(result->nodesetval);
    xmlXPathFreeContext(context);

    return 0;
}

void MostrarNodos(xmlNodeSetPtr nodos) {
    xmlNodePtr cur;
    int size;
    int i;

    size = (nodos) ? nodos->nodeNr : 0;

    std::cout << "Encontrados: " << size << " nodos" << std::endl;
    for(i = 0; i < size; ++i) {
        if(nodos->nodeTab[i]->type == XML_ATTRIBUTE_NODE) {
            cur = nodos->nodeTab[i];
            std::cout << i+1 << ")  enlace " << " -> ";
            if(cur->children) std::cout << cur->children->content;
            std::cout << std::endl;
        }
    }
}
